#!/usr/bin/perl -w

use strict;

if( @ARGV == 0 ) {
   print "Usage: $0 <filename>\n";
   exit;
}

open( INFILE, '<', $ARGV[0] ) or die "Can't open file $ARGV[0].\n";

my %beaker = ();
my %distcoil = ();
my %florence = ();
my %testtube = ();
my %thistle = ();

foreach( <INFILE> ) {
   if( (my $qty, my $qual) = /(\d+) Beaker:Quality (\d+)/ ) {
      $beaker{$qual} = $qty;
   }
   if( (my $qty, my $qual) = /(\d+) Distillation Coil:Quality (\d+)/ ) {
      $distcoil{$qual} = $qty;
   }
   if( (my $qty, my $qual) = /(\d+) Florence Flask:Quality (\d+)/ ) {
      $florence{$qual} = $qty;
   }
   if( (my $qty, my $qual) = /(\d+) Test Tube:Quality (\d+)/ ) {
      $testtube{$qual} = $qty;
   }
   if( (my $qty, my $qual) = /(\d+) Thistle Tube:Quality (\d+)/ ) {
      $thistle{$qual} = $qty;
   }
}

close( INFILE );

my @sets = ();

foreach my $beaker ( keys %beaker ) {
   foreach my $distcoil ( keys %distcoil ) {
      foreach my $florence ( keys %florence ) {
         foreach my $testtube ( keys %testtube ) {
            foreach my $thistle ( keys %thistle ) {
               if( ( ( ($beaker + $distcoil + $florence + $testtube + $thistle) >= 40000 ) &&
                     ( ($beaker + $distcoil + $florence + $testtube + $thistle) < 40005 ) )   ||
                   ( ( ($beaker + $distcoil + $florence + $testtube + $thistle) >= 45000 ) &&
                     ( ($beaker + $distcoil + $florence + $testtube + $thistle) < 45005 ) ) ) {
                  push( @sets, [ $beaker, $distcoil, $florence, $testtube, $thistle ] );
                  $beaker{$beaker}--;
                  $distcoil{$distcoil}--;
                  $florence{$florence}--;
                  $testtube{$testtube}--;
                  $thistle{$thistle}--;
               }
            }
         }
      }
   }
}  

print scalar(@sets) . " sets found.\n";

foreach( 0 .. $#sets ) {
   print $_+1;
   print ": Beaker $sets[$_][0], Distillation Coil $sets[$_][1], Florence Flask $sets[$_][2], Test Tube $sets[$_][3], Thistle Tube $sets[$_][4]\n";
}

print "\n";

foreach my $beaker ( keys %beaker ) {
   if( $beaker{$beaker} < 0 ) {
      my @conf = ();
      foreach( 0 .. $#sets ) {
         if( $sets[$_][0] == $beaker ) {
            push( @conf, $_ );
         }
      }
      print "Conflict: Beaker $beaker, used in sets " . join(', ', @conf) . "\n";
   }
}

foreach my $distcoil ( keys %distcoil ) {
   if( $distcoil{$distcoil} < 0 ) {
      my @conf = ();
      foreach( 0 .. $#sets ) {
         if( $sets[$_][1] == $distcoil ) {
            push( @conf, $_ );
         }
      }
      print "Conflict: Distillation Coil $distcoil, used in sets " . join(', ', @conf) . "\n";
   }
}

foreach my $florence ( keys %florence ) {
   if( $florence{$florence} < 0 ) {
      my @conf = ();
      foreach( 0 .. $#sets ) {
         if( $sets[$_][2] == $florence ) {
            push( @conf, $_ );
         }
      }
      print "Conflict: Florence Flask $florence, used in sets " . join(', ', @conf) . "\n";
   }
}

foreach my $testtube ( keys %testtube ) {
   if( $testtube{$testtube} < 0 ) {
      my @conf = ();
      foreach( 0 .. $#sets ) {
         if( $sets[$_][3] == $testtube ) {
            push( @conf, $_ );
         }
      }
      print "Conflict: Test Tube $testtube, used in sets " . join(', ', @conf) . "\n";
   }
}

foreach my $thistle ( keys %thistle ) {
   if( $thistle{$thistle} < 0 ) {
      my @conf = ();
      foreach( 0 .. $#sets ) {
         if( $sets[$_][4] == $thistle ) {
            push( @conf, $_ );
         }
      }
      print "Conflict: Thistle Tube $thistle, used in sets " . join(', ', @conf) . "\n";
   }
}

